<template lang='pug'>
BaseDialog.x-create-transform-dialog(ref='dialog' title='Add Transform' @hidden='isFocused = !$event')
  template(v-slot:title)
    h5.modal-title Add Transform
    button.btn.btn-sm.btn-outline-info.ml-auto.mx-1(title='info' @click='showInfo = !showInfo')
      kbd.mr-2(v-if="showKeyHints && isFocused") Ctrl+H
      | #[i.fa.fa-question-circle]

  template(v-if='query')
    BaseAnimationGroup.row.justify-content-center(anim="height")
      template(v-if='showInfo')
        .col-12.mb-3(key='info')
          InfoAlert
            p The #[strong Create Transform] dialog guides you to create a new transform
            p #[strong Note:] Add or remove transforms using #[i.fa.fa-plus] and #[i.fa.fa-times]
            p #[strong Note:] The transform order is important, drag &amp; drop transforms to order it using #[i.fa.fa-grip-vertical]
      .col-12(key='query')
        .input-group.input-group-sm
          .input-group-prepend
            button.text-monospace.btn.btn-secondary(type='button' disabled='1') query-selector
          span.form-control.text-truncate.right.text-monospace.shadow-none(type='text' readonly='1' :value='query') {{ query }}
      .col-12(key='values')
        .row
          .col-12
            ErrorList(ref='errList')
          .col-12.col-md-6
            Input.p-0(ref='attribute-type' name='attribute-type' :inEdit='true')
              template(#default='d')
                select(v-model='d.$data.editValue')
                  option(value='' selected='1') (no set)
                  option(value='auto') auto
                  option(value='CSS') CSS
                  option(value='XML') XML
          .col-12.col-md-6
            Input.p-0(ref='calc-mode' name='calc-mode' :inEdit='true')
              template(#default='d')
                select(v-model='d.$data.editValue')
                  option(value='' selected='1') (no set)
                  option(value='linear') linear
                  option(value='discrete') discrete
          .col-12.mt-2
            datalist(id='transformList')
              option(v-for='t in $options.transformList') {{ t }}
            draggable.list-group.shadow(key='edit' :list='transforms' ghost-class='list-group-item-primary' handle='.x-grip')
              li.list-group-item.d-flex.align-items-center.justify-content-between.px-0.py-1(
                  v-for='value, idx in transforms' :key='`${reqId}-${idx}`')
                div.px-2.b-clickable.x-grip
                  i.fa.fa-grip-vertical
                .row.no-gutters.w-100
                  .col-12.col-md-4.align-self-center.px-1
                    Input.p-0(v-if="!value.custom" ref='transform' :value='value.transform' :inEdit='true' @edit='value.custom = (value.transform === "custom")')
                      template(#default='d')
                        select(v-model='d.$data.editValue' @change='updateTransform(idx, $event.target.value)')
                          option custom
                          option(v-for='t in $options.transformList') {{ t }}
                    Input.p-0(v-else v-model='value.transform' :inEdit='true')
                      template(#default='d')
                        input(type='text' v-model='d.$data.editValue' list='transformList')
                  .col-6.col-md-4.align-self-center.px-1
                    Input.p-0(ref='from' name='from' :value='transformArgsStr(value.args[0], value.units)' :inEdit='true')
                      template(#default='d')
                        input(type='text' v-model='d.$data.editValue' @change='updateArgs(idx, 0, $event.target.value)')
                  .col-6.col-md-4.align-self-center.px-1
                    Input.p-0(ref='to' name='to' :value='transformArgsStr(value.args[1], value.units)' :inEdit='true')
                      template(#default='d')
                        input(type='text' v-model='d.$data.editValue' @change='updateArgs(idx, 1, $event.target.value)')
                div.px-2.b-clickable(@click='removeAt(idx)')
                  i.fa.fa-times
          .col-12.d-flex.justify-content-end
            .dropdown.my-1
              button.btn.btn-sm.btn-primary(title='Add' type="button" @click='addTransform')
                | #[i.fa.fa-plus] Add
  template(v-slot:footer='d')
    button.btn.btn-secondary(@click='d.resolve(false)') Cancel
    button.btn.btn-primary(:disabled='!isValid' @click='d.resolve(true)') Create
</template>
<script src='./CreateTransformDialog.vue.js' />
<style lang="scss">
.x-create-transform-dialog {
  .row {
    align-items: flex-end !important;
  }
}
</style>
